#!/usr/bin/perl
#------------------------------------------------------------------------------
# Script:	pdedit.cgi
#
# Author:	Peter Sundstrom (Ginini Technologies Limited)
#
# Source:	http://postcard-direct.com/
#
# Copyright:	(c)1999-2005 Peter Sundstrom.
#		All rights reserved.
#
#------------------------------------------------------------------------------

use strict;

use CGI::Carp qw(carpout fatalsToBrowser);

BEGIN {
	use FindBin qw($Bin);
	if ($Bin) {
		if ($Bin eq '/') {
			$Bin='';
		}
		else {
			$Bin .= '/';
			chdir $Bin or die "Can not change directory to $Bin $!\n";
		}
	}

	require "${Bin}configs/pdconfig.txt";
}

use CGI;
use File::Copy;
use Cwd;
use lib "${Bin}modules";
use vars qw($tkey);
$tkey=$ENV{'SERVER_NAME'};
use pdcommon;

require tea;
Crypt::Tea->import();

#
# Make an attempt to ensure this script has been invoked
# on this server, or least from a specified server.
#
# Currently commented due to the way this script is
# invoked in a new window and no referer data is generated.
#CheckReferer();

my $q = new CGI;
my $script = $q->url(absolute=>1);
my $action=$q->param('action');

print $q->header(-expires=>'now');

Checklogin($q);

if ($action eq 'Save') {
	Save();
}
elsif ($action eq 'Edit') {
	Edit();
}
else {
	Error("Invalid action specified: $action");
}


#------------------------------------------------------------------------------
sub Edit {
	my $relfile=$q->param('file');
	my ($data,$file);

	Error("No file specified") unless $relfile;

	Error("Illegal pathname: $relfile") if CheckBadPath($relfile,'subdir');

	#
	# Try a couple of ways to obtain the full path.
	#
	my $dir=cwd();

	if ($dir) {
		$file="$dir/$relfile";
	}
	else {
		$file="${Bin}$relfile";
	}

	Error("$file not found") unless -f $file;

	open(FORM,$file) or Error("Can not open $file",$!);

	$data .= $q->escapeHTML($_) while (<FORM>);

	close(FORM);

	my $style=Stylesheet('pdedit.css');

	print <<EOF;
<html>
<head>
<title>$file</title>
$style
</head>

<body bgcolor="#ffffff">
<h3>$file</h3>
<form action="$script" method="post">

<textarea name="text" rows="20" cols="80">
$data
</textarea>

<p>
<input type="hidden" name="file" value="$relfile">

<input type="submit" name="action" value="Save">
<input type="button" value="Cancel" onClick="window.close()">
</p>

</form>

</body>
</html>
EOF
}

#------------------------------------------------------------------------------
sub Save {
	my $relfile = $q->param('file');
	my $text = $q->param('text');
	my $file;

	Error("No file specified") unless $relfile;
	Error("Illegal pathname: $relfile") if CheckBadPath($relfile,'subdir');

	#
	# Try a couple of ways to obtain the full path
	#
	my $dir=cwd();

	if ($dir) {
		$file="$dir/$relfile";
	}
	else {
		$file="${Bin}$relfile";
	}

	Error("Filename $file does not exist") unless -f $file;

	copy($file,"$file.bak") or Error("Can not copy $file to $file.bak",$!);

	open(FILE,">$file") or Error("Can not open $file",$!);
	print FILE $q->param('text');
	close(FILE);

	my $style=Stylesheet('pdedit.css');

	print <<EOF;
<html>
<head>
<title>Saved $file</title>
$style
</head>

<body bgcolor="#ffffff">
<h3>Saved $file</h3>
<input type="button" value="Close" onClick="window.close()">
</body>
</html>
EOF
}

